= Available and Supported Antora Components
:page-aliases: pipeline:supported-components.adoc
:navtitle: Antora Components
:table-caption!:
// URLs
:url-antora-lcs: https://gitlab.com/antora/antora/blob/HEAD/LICENSE

On this page, you'll find the list of Antora components that can be assembled into a custom site generator pipeline.
Antora has a modular architecture so that components can be easily removed and replaced.
Due to its API, you can also integrate Asciidoctor extensions.

[#core]
== Core components

Core components are assembled into a pipeline by the Site Generator Default component.
The Core components are versioned together.

At this time, only Core components with the same version are designed to work together.
For example, if you want to use the Content Classifier and Page Composer in a custom site generator, make sure each component has the same version.

If you use the CLI (`@antora/cli`) with the default site generator (`@antora/site-generator-default`), then you just have to keep the versions of the CLI and the default site generator in sync.
If you make a custom site generator, you are responsible for keeping each individual component you use in sync.

== Extended components

Extended components provide key functionality for special use cases.
An example of an Extended component is a site publisher provider for an Amazon S3 bucket.
Once ready for xref:ROOT:project/release-schedule.adoc[general availability], Extended components are released and versioned individually.

[#component-matrix]
== Supported Core and Extended components matrix

[cols="2,4,1,1,1"]
|===
|Component |Description |Core |Extended |License

|AsciiDoc Loader
|Reusable library for handling AsciiDoc content in Antora.
It loads AsciiDoc content into an AsciiDoc Document object (AST).
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|CLI
|Command line interface (CLI) for Antora.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Content Aggregator
|Fetches and aggregates content distributed across multiple local and remote git repositories.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Content Classifier
|Organizes aggregated content into a virtual file catalog.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Document Converter
|Converts AsciiDoc documents to embeddable HTML.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Logger
|Provides the infrastructure for logging, shaping, and reporting application messages.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Navigation Builder
|Builds a navigation catalog sourced from navigation files.
This navigation catalog can be used to add site navigation to pages.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Page Composer
|Wraps the embeddable HTML contents of each page file from the content catalog in an HTML page layout.
This step yields the standalone HTML pages in the generated site.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Playbook Builder
|The configuration component that builds a playbook object from user input.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Redirect Producer
|Produces redirects (HTTP redirections) to a given page from its registered aliases.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Site Generator Default
|The default site generator pipeline for Antora.
Invoked by the `generate` command of Antora's CLI to produce and publish static documentation sites.
This package groups (i.e., has a dependency on) all the other packages in core except for the CLI.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Site Mapper
|Generates the sitemap files for the site.
These files, which are intended to be read by crawlers, provide a list of all published pages by URL.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|Site Publisher
|Publishes (i.e., writing) the generated files to the destination(s) specified in the playbook.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]

|UI Loader
|Downloads and caches the UI bundle, then extracts and loads the files from that bundle into a UI catalog.
The UI files are combined with the content files at the end of the Antora documentation pipeline to produce a complete site.
|&#10003;
|
|{url-antora-lcs}[MPL-2.0^]
|===

// Custom components
